% Programma per la risoluzione numerica di
% sistemi di equazioni differenziali con diversi metodi
% Corso MNED 2010/2011 - Studente bla...
testfunction=3;
h=0.001;

hhmeth1=zeros(6,1);
hhmeth2=zeros(size(hhmeth1));
hherr1=zeros(5,1);
hherr2=hherr1;
hhmethp=hhmeth1;
labmeth={'True','ode23','Euler','ode23s','RK2','RK4'};
laberr={'ode23','Euler','ode23s','RK2','RK4'};

switch testfunction
    case 1
        % y'(1)=3*y(1)+2*y(2)
        % y'(2)=4*y(1)+y(2)
        % y(1)=(exp(5*t)-exp(-t))/3
        % y(2)=(exp(5*t)+2*exp(-t))/3
        % y(1)_0=0; y(2)_0=1
        % T=[0,1]
        f=inline('[3*y(1)+2*y(2); 4*y(1)+y(2)]','t','y');
        solution=inline('[(exp(5*t)-exp(-t))/3 (exp(5*t)+2*exp(-t))/3]');
        y0=[0 1];
        DT=[0 1];
    case 2
        % Equazioni Lotka-Volterra
        % y'(1)=3*y(1)+2*y(2)
        % y'(2)=4*y(1)+y(2)
        % y(1)=(exp(5*t)-exp(-t))/3
        % y(2)=(exp(5*t)+2*exp(-t))/3
        % y(1)_0=0; y(2)_0=1
        % T=[0,1]
        f=inline('[(1-0.01*y(2))*y(1); (-1+0.02*y(1))*y(2)]','t','y');
        solution=NaN;
        y0=[20 20];
        DT=[0 15];
    case 3
        % Equazione stiff
        % y'(1)=998*y(1)+1998*y(2)
        % y'(2)=-999*y(1)-1999*y(1)
        % y(1)=2*exp(-t)-exp(-1000*t)
        % y(2)=-exp(-t)+exp(-1000*t)
        % y(1)_0=1; y(2)_0=0
        % T=[0,1]
        f=inline('[998*y(1)+1998*y(2); -999*y(1)-1999*y(2)]','t','y');
        solution=inline('[2*exp(-t)-exp(-1000*t), -exp(-t)+exp(-1000*t)]');
        y0=[1 0];
        DT=[0 1];
    case 4
        % Equazione stiff
        % y'(1)=y(2)
        % y'(2)=100*y(1)
        % y(1)=exp(-10*t)
        % y(2)=-10*exp(-10*t)
        % y(1)_0=1; y(2)_0=-10
        % T=[0,1]
        f=inline('[y(2); 100*y(1)]','t','y');
        solution=inline('[exp(-10*t), -10*exp(-10*t)]');
        y0=[1 -10];
        DT=[0 1];
end

% MATLAB ode23
fprintf('ODE23 - ')

tic
[t,y]=ode23(f,DT,y0);
tim=toc;

figure(1)
set(gcf,'Name','Solution plot')
clf


if testfunction ~= 2
    ytrue=solution(t);
    subplot(2,2,1)
    hhmeth1(1)=plot(t,ytrue(:,1),'--k','LineWidth',2);
    hold on
    subplot(2,2,3)
    hhmeth2(1)=plot(t,ytrue(:,2),'--k','LineWidth',2);
    hold on
    subplot(2,2,2)
    hherr1(1)=plot(t,y(:,1)-ytrue(:,1),'r');
    hold on
    subplot(2,2,4)
    hherr2(1)=plot(t,y(:,2)-ytrue(:,2),'r');
    hold on
    maxerr=max(abs(y-ytrue));
    fprintf('L-infty error: %f -%f -- ',maxerr)
end

subplot(2,2,1)
hhmeth1(2)=plot(t,y(:,1),'r');
hold on% ode23s
fprintf('ODE23S - ')

tic
[t,y]=ode23s(f,DT,y0);
tim=toc;


subplot(2,2,3)
hhmeth2(2)=plot(t,y(:,2),'r');
hold on
fprintf('CPU time: %f\n',tim)

figure(2)
set(gcf,'Name','Phase plane plot')
clf

if testfunction ~= 2
    hhmethp(1)=plot(ytrue(:,1),ytrue(:,2),'k','LineWidth',2);
end
hold on

hhmethp(2)=plot(y(:,1),y(:,2),'r');

% EULER
fprintf('EULERO - ')

tic
[t,y]=myeuler(f,DT,y0,h);
tim=toc;

figure(1)

if testfunction ~= 2
    ytrue=solution(t);
    subplot(2,2,2)
    hherr1(2)=plot(t,y(:,1)-ytrue(:,1),'b');
    hold on
    subplot(2,2,4)
    hherr2(2)=plot(t,y(:,2)-ytrue(:,2),'b');
    hold on
    maxerr=max(abs(y-ytrue));
    fprintf('L-infty error: %f -%f -- ',maxerr)
end

subplot(2,2,1)
hhmeth1(3)=plot(t,y(:,1),'b');
subplot(2,2,3)
hhmeth2(3)=plot(t,y(:,2),'b');
fprintf('CPU time: %f\n',tim)

figure(2)

hhmethp(3)=plot(y(:,1),y(:,2),'b');

% ode23s
fprintf('ODE23S - ')

tic
[t,y]=ode23s(f,DT,y0);
tim=toc;

figure(1)

if testfunction ~= 2
    ytrue=solution(t);
    subplot(2,2,2)
    hherr1(3)=plot(t,y(:,1)-ytrue(:,1),'g');
    hold on
    subplot(2,2,4)
    hherr2(3)=plot(t,y(:,2)-ytrue(:,2),'g');
    hold on
    maxerr=max(abs(y-ytrue));
    fprintf('L-infty error: %f -%f -- ',maxerr)
end

subplot(2,2,1)
hhmeth1(4)=plot(t,y(:,1),'g');
subplot(2,2,3)
hhmeth2(4)=plot(t,y(:,2),'g');
fprintf('CPU time: %f\n',tim)

figure(2)

hhmethp(4)=plot(y(:,1),y(:,2),'g');

% RUNGE KUTTA 2
fprintf('Runge Kutta ordine 2 ')

tic
[t,y]=myrk2(f,DT,y0,h);
tim=toc;

figure(1)

if testfunction ~= 2
    ytrue=solution(t);
    subplot(2,2,2)
    hherr1(4)=plot(t,y(:,1)-ytrue(:,1),'c');
    hold on
    subplot(2,2,4)
    hherr2(4)=plot(t,y(:,2)-ytrue(:,2),'c');
    hold on
    maxerr=max(abs(y-ytrue));
    fprintf('L-infty error: %f -%f -- ',maxerr)
end

subplot(2,2,1)
hhmeth1(5)=plot(t,y(:,1),'c');
subplot(2,2,3)
hhmeth2(5)=plot(t,y(:,2),'c');
fprintf('CPU time: %f\n',tim)

figure(2)

hhmethp(5)=plot(y(:,1),y(:,2),'c');

% RUNGE KUTTA 4
fprintf('Runge Kutta ordine 4 ')

tic
[t,y]=myrk4(f,DT,y0,h);
tim=toc;

figure(1)

if testfunction ~= 2
    ytrue=solution(t);
    subplot(2,2,2)
    hherr1(5)=plot(t,y(:,1)-ytrue(:,1),'y');
    hold on
    subplot(2,2,4)
    hherr2(5)=plot(t,y(:,2)-ytrue(:,2),'y');
    hold on
    maxerr=max(abs(y-ytrue));
    fprintf('L-infty error: %f -%f -- ',maxerr)
end

subplot(2,2,1)
hhmeth1(6)=plot(t,y(:,1),'y');
subplot(2,2,3)
hhmeth2(6)=plot(t,y(:,2),'y');
fprintf('CPU time: %f\n',tim)

figure(2)

hhmethp(6)=plot(y(:,1),y(:,2),'y');


% end methods

if testfunction == 2
    hhmeth1(1)=[];
    hhmeth2(1)=[];
    hhmethp(1)=[];
    labmeth(1)=[];
end
figure(1)
subplot(2,2,1)
xlabel('t')
ylabel('y_1')
title('Time history - solution')
legend(hhmeth1,labmeth,'Location','Best')
subplot(2,2,3)
xlabel('t')
ylabel('y_2')
title('Time history - solution')
legend(hhmeth2,labmeth,'Location','Best')
if testfunction ~= 2
subplot(2,2,2)
xlabel('t')
ylabel('y_1')
title('Time history - L_\infty Error')
legend(hherr1,laberr,'Location','Best')
subplot(2,2,4)
xlabel('t')
ylabel('y_2')
title('Time history - L_\infty Error')
legend(hherr2,laberr,'Location','Best')
end
figure(2)
xlabel('y_1')
ylabel('y_2')
title('Phase plane plot')
legend(hhmethp,labmeth,'Location','Best')
